image: node:latest
cache:
  key: "$CI_COMMIT_SHA"
  paths:
    - node_modules
stages:
  - setup
  - test
  - deploy

npm_install:
  stage: setup
  script:
    - echo $CI_COMMIT_REF_NAME / $CI_DEFAULT_BRANCH, branch is $CI_COMMIT_BRANCH, tag is $CI_COMMIT_TAG, protected? $CI_COMMIT_REF_PROTECTED
    - echo $CI_COMMIT_MESSAGE
    - npm install
  artifacts:
    paths:
      - node_modules

test_report:
  stage: test
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script: npm test
  artifacts:
    reports:
      cobertura: coverage/cobertura-coverage.xml
test_quick:
  stage: test
  rules:
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
  script: npm run qtest

publish:
  stage: deploy
  rules:
    - if: $CI_COMMIT_TAG && $CI_COMMIT_REF_PROTECTED == "true"
  script:
    - npm config set //registry.npmjs.org/:_authToken=${NPM_TOKEN}
    - npm publish
